#include <iostream>
#include <fstream>
using namespace std;

class Utilizator
{
	char *nume;
	int nrParole;
	char **parole;
	const int id;
	char categ;
	static int nrAdmini;
	static int nrUseri;

public:
	Utilizator():id(0)
	{
		nume = new char[strlen("Anonim")+1];
		strcpy(nume, "Anonim");
		nrParole = 1;
		parole = new char*[nrParole];
		parole[0] = new char[strlen("abcd")+1];
		strcpy(parole[0], "abcd");
		categ = 'A';
		nrAdmini++;
	}

	Utilizator(char *n, int nrp, char**p, int i, char c):id(i)
	{
		nume = new char[strlen(n)+1];
		strcpy(nume, n);
		nrParole = nrp;
		parole = new char*[nrParole];
		for(int j=0;j<nrParole;j++)
		{
			parole[j] = new char[strlen(p[j])+1];
			strcpy(parole[j], p[j]);
		}
		categ = c;
		if (categ=='A')
			nrAdmini++;
		else 
			nrUseri++;
	}

	~Utilizator()
	{
		delete[] nume;
		for(int i=0;i<nrParole;i++)
			delete[] parole[i];
		delete[] parole;

		if(categ=='A')
			nrAdmini--;
		else
			nrUseri--;
	}

	void afisare()
	{
		cout<<"Utilizatorul "<<nume<<" cu id-ul "<<id<<" si categoria "<<
			categ<<" are "<<nrParole<<" parole"<<endl;
		cout<<"Paroelele sunt: "<<endl;
		for(int i=0;i<nrParole;i++)
			cout<<parole[i]<<" ";
		cout<<endl;
	}

	static int getNrAdmini()
	{
		return nrAdmini;
	}

	static int getNrUseri()
	{
		return nrUseri;
	}

	Utilizator(bool vb):id(123)
	{
		if(vb==true)
		{
			cout<<"Nume: "<<endl;
			char buffer[20];
			cin>>buffer;
			nume = new char[strlen(buffer)+1];
			strcpy(nume, buffer);
			cout<<"Nr parole: "<<endl;
			cin>>nrParole;
			cout<<"Vector parole: "<<endl;
			parole = new char*[nrParole];
			for(int i=0;i<nrParole;i++)
			{
				cin>>buffer;
				parole[i] = new char[strlen(buffer)+1];
				strcpy(parole[i], buffer);
			}
			cout<<"Categorie: "<<endl;
			cin>>categ;
			if(categ=='A')
				nrAdmini++;
			else 
				nrUseri++;
		}
		else
		{
			ifstream f("fisier.txt", ios_base::in);
			//cout<<"Nume: "<<endl;
			char buffer[20];
			f>>buffer;
			nume = new char[strlen(buffer)+1];
			strcpy(nume, buffer);
			//cout<<"Nr parole: "<<endl;
			f>>nrParole;
			//cout<<"Vector parole: "<<endl;
			parole = new char*[nrParole];
			for(int i=0;i<nrParole;i++)
			{
				f>>buffer;
				parole[i] = new char[strlen(buffer)+1];
				strcpy(parole[i], buffer);
			}
			//cout<<"Categorie: "<<endl;
			f>>categ;
			if(categ=='A')
				nrAdmini++;
			else 
				nrUseri++;
			f.close();
		}
	}
};

int Utilizator::nrAdmini = 0;
int Utilizator::nrUseri = 0;

void main()
{
	Utilizator u1;
	char* vp[3] = {"abc123", "def123", "xyzw"};
	Utilizator u2("Gigel",3,vp,123,'A');

	u1.afisare();
	u2.afisare();

	char* vp1[4] = {"abc123", "def123", "xyzw", "abcd"};
	//u2.setParole(vp1, 4);

	//Utilizator u3(true);
	//u3.afisare();

	Utilizator u4(false);
	u4.afisare();

	cout<<"Nr admini: "<<Utilizator::getNrAdmini()<<endl;
	cout<<"Nr useri: "<<Utilizator::getNrUseri()<<endl;
}