#include <iostream>
using namespace std;

class Angajat
{
	int varsta;
	char *nume;
	float salariu;
	char sex;
	int nrProiecte;
	int *vectOreProiecte;

	static int nrAnagajati;

public:
	Angajat()
	{
		varsta = 0;
		nume = new char[strlen("Anonim")+1];
		strcpy(nume, "Anonim");
		salariu = 0.0f;
		sex = 'M';
		nrProiecte = 0;
		vectOreProiecte = NULL;
		nrAnagajati++;
	}

	Angajat(int v, char *n, float s, char sx, int nr, int *vp)
	{
		varsta = v;
		nume = new char[strlen(n)+1];
		strcpy(nume, n);
		salariu = s;
		sex = sx;
		nrProiecte = nr;
		vectOreProiecte = new int[nrProiecte];
		for(int i=0;i<nrProiecte;i++)
			vectOreProiecte[i] = vp[i];
		nrAnagajati++;
	}

	~Angajat()
	{
		delete[] nume;
		delete[] vectOreProiecte;
		nrAnagajati--;
	}

	void afisare()
	{
		cout<<"Angajatul "<<nume<<" cu varsta "<<varsta<<
			" are salariul "<<salariu<<" sexul "<<sex<<" si lucreaza pe "<<nrProiecte<<" proiecte"<<endl;
		cout<<"Orele lucrate sunt: "<<endl;
		for(int i=0;i<nrProiecte;i++)
			cout<<vectOreProiecte[i]<<" ";
		cout<<endl;
	}

	int getVarsta()
	{
		return varsta;
	}

	void setVarsta(int v)
	{
		if(v>0) varsta = v;
	}

	char* getNume()
	{
		return nume;
	}

	void setNume(char *n)
	{
		delete[] nume;
		nume = new char[strlen(n)+1];
		strcpy(nume, n);
	}

	void setVectOreProiecte(int *v, int nr)
	{
		delete[] vectOreProiecte;
		nrProiecte = nr;
		vectOreProiecte = new int[nrProiecte];
		for(int i=0;i<nrProiecte;i++)
			vectOreProiecte[i] = v[i];
	}

	float medie()
	{
		int suma = 0;
		for(int i=0;i<nrProiecte;i++)
			suma += vectOreProiecte[i];
		return (float)suma/nrProiecte;
	}

	static int getNrAngajati()
	{
		return nrAnagajati;
	}
};

int Angajat::nrAnagajati = 0;

void main()
{
	Angajat a1;
	int v[3] = {10, 12, 5};
	Angajat a2(25, "Gigel", 2000, 'M', 3, v);
	a1.afisare();
	a2.afisare();

	a2.setVarsta(27);
	a2.setNume("Maricica");
	cout<<a2.getVarsta()<<" "<<a2.getNume()<<endl;
	a2.afisare();

	int v2[5] = {12, 14, 5, 7, 9};
	a2.setVectOreProiecte(v2, 5);
	a2.afisare();

	cout<<"Nr mediu ore lucrate: "<<a2.medie()<<endl;

	cout<<"Nr nagajati: "<<Angajat::getNrAngajati()<<endl;
}