#include <iostream>
using namespace std;

class Profesor
{
	char* nume;
	int varsta;
	const float salariu;
	int nrDiscipline;
	char** discipline;
	char sex;

	

public:

	static int nrBarbati;
	static int nrFemei;

	Profesor():salariu(0)
	{
		nume = new char[strlen("Anonim")+1];
		strcpy(nume, "Anonim");
		varsta = 0;
		nrDiscipline = 1;
		discipline = new char*[nrDiscipline];
		discipline[0] = new char[strlen("POO")+1];
		strcpy(discipline[0], "POO");
		sex = 'F';
		nrFemei++;
	}

	Profesor(char*n, int v, float sal, int nr, char**discip, char s):salariu(sal)
	{
		nume = new char[strlen(n)+1];
		strcpy(nume, n);
		varsta = v;
		nrDiscipline = nr;
		discipline = new char*[nrDiscipline];
		for(int i=0;i<nrDiscipline;i++)
		{
			discipline[i] = new char[strlen(discip[i])+1];
			strcpy(discipline[i], discip[i]);
		}
		sex = s;
		if(sex=='M')
			nrBarbati++;
		else
			nrFemei++;
	}

	~Profesor()
	{
		delete[] nume;
		for(int i=0;i<nrDiscipline;i++)
			delete[] discipline[i];
		delete[] discipline;
		if(sex=='M')
			nrBarbati--;
		else
			nrFemei--;
	}

	Profesor(Profesor &p):salariu(p.salariu)
	{
		nume = new char[strlen(p.nume)+1];
		strcpy(nume, p.nume);
		varsta = p.varsta;
		nrDiscipline = p.nrDiscipline;
		discipline = new char*[nrDiscipline];
		for(int i=0;i<nrDiscipline;i++)
		{
			discipline[i] = new char[strlen(p.discipline[i])+1];
			strcpy(discipline[i], p.discipline[i]);
		}
		sex = p.sex;
		if(sex=='M')
			nrBarbati++;
		else
			nrFemei++;
	}

	void afisare()
	{
		cout<<"Profesorul "<<nume<<" cu varsta "<<varsta<<
			" salariul "<<salariu<<" si sexul "<<sex<<
			" preda la "<<nrDiscipline<<" discipline"<<endl;
		cout<<"Lista disciplinelor: "<<endl;
		for(int i=0;i<nrDiscipline;i++)
			cout<<discipline[i]<<" ";
		cout<<endl;
	}

	Profesor operator=(Profesor p)
	{
		delete[] this->nume;
		this->nume = new char[strlen(p.nume)+1];
		strcpy(this->nume, p.nume);
		this->varsta = p.varsta;
		for(int i=0;i<this->nrDiscipline;i++)
			delete[] this->discipline[i];
		delete[] this->discipline;
		this->nrDiscipline = p.nrDiscipline;
		this->discipline = new char*[this->nrDiscipline];
		for(int i=0;i<this->nrDiscipline;i++)
		{
			this->discipline[i] = new char[strlen(p.discipline[i])+1];
			strcpy(this->discipline[i], p.discipline[i]);
		}
		if(this->sex=='M')
			nrBarbati--;
		else
			nrFemei--;
		this->sex = p.sex;
		if(this->sex=='M')
			nrBarbati++;
		else
			nrFemei++;
		return *this;
	}
};

int Profesor::nrBarbati = 0;
int Profesor::nrFemei = 0;

void main()
{
	Profesor p1;
	char *discip[3] = {"SDD", "Java", "ATP"};
	Profesor p2("Gigel",35,2000,3,discip,'M');

	Profesor p3(p2);
	Profesor p4 = p2;

	cout<<"Nr barbati: "<<Profesor::nrBarbati<<endl;
	cout<<"Nr femei: "<<Profesor::nrFemei<<endl;

	p3 = p1;


	cout<<"Nr barbati: "<<Profesor::nrBarbati<<endl;
	cout<<"Nr femei: "<<Profesor::nrFemei<<endl;

	p1.afisare();
	p2.afisare();
	p3.afisare();
	p4.afisare();
}